/**
 * Script Copyright by Sebastiaan Mindreau.
 * Free use for educational/non-profit use.
 * (c) 2007 (25/01 @ 0:21)
 *
 *
 * Also fixes the headers of a table
 *
 */
 

// Constant defining the maximum length of a string in the table
var TRIGGER_VALUE = 10;

/**
 * Checks every cell in the table, by using the fixString() function.
 *
 * You could use this script when a user presses a button,
 * just put this function as the onClick command of the button/image.
 * 
 * Or just use it (as default) when the page loads, use the 
 * onload parameter of the body tag.
 *
 * @param maxLength Maximum length of the cell contents
 */
function checkTable(maxLength) {
  var belovedTable = document.getElementById("myBelovedTable");
  if(belovedTable == null)
    return;
  if(maxLength == null || maxLength == "")
    maxLength = TRIGGER_VALUE;
  fixOneTable(belovedTable, maxLength);
}

/**
 * This function fixes one table at a time.
 * Handy to use when fixing multiple tables!
 *
 * @param maxLength Maximum length of the cell contents
 */
function fixOneTable(belovedTable, maxLength) {
	for(i=0; i<belovedTable.rows.length; i++) {
    belovedRow = belovedTable.rows[i];
	if(belovedRow == null)
	  break;
    for(j=0; j<belovedRow.cells.length; j++) {
	  belovedCell = belovedRow.cells[j];
	  if(belovedCell == null)
	    break;
	  if(belovedCell.innerHTML.length > maxLength-1)
	    belovedCell.title = belovedCell.innerHTML;
	  belovedCell.innerHTML = fixString(belovedCell.innerHTML, maxLength);
    }
  }	
}

/**
 * A slight variant on the theme, is multiple tables have to be
 * fixed.
 * Requires all tables to have the same id
 * Watch out: the index k is used because else it conflicts with either
 * i or j of the fixOneTable method.
 *
 * @param maxLength Maximum length of the cell contents
 */
function checkTables(maxLength) {
	if(maxLength == null || maxLength == "")
	  maxLength = TRIGGER_VALUE;
	var belovedTables = document.getElementsByTagName("table");
	for(k=0; k<belovedTables.length; k++) {
		var belovedTable = belovedTables[k];
		if(belovedTable.id == "myBelovedTable") {
			fixOneTable(belovedTable, maxLength);
		}
	}
}

/**
 * Shortens the string to size maxLength
 *
 * @param maxLength Maximum length of the cell contents
 */
function fixString(txt, maxLength) {
  if(belovedCell.innerHTML.length > maxLength-1)
    return txt.substr(0, maxLength-3) + "...";
  else 
    return txt;
}